unit AMHotSpot;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, ExtCtrls;

type
  TCmMouseEnter = record
    Msg: Cardinal;
    Unused: Integer;
    Sender: TControl;
    Result: LongInt;
  end;
  TCmMouseLeave = TCmMouseEnter;

  TMouseEnter = procedure (Sender: TControl; var Message: TCmMouseEnter) of object;
  TMouseLeave = procedure (Sender: TControl; var Message: TCmMouseLeave) of object;

  TAMHotSpot = class(TGraphicControl)
  private
    { Private declarations }
    FMouseEnter: TMouseEnter;
    FMouseLeave: TMouseLeave;
  protected
    { Protected declarations }
    procedure Paint; override;
    procedure CMMouseEnter(var Message: TCmMouseEnter); message CM_MOUSEENTER;
    procedure CMMouseLeave(var Message: TCmMouseLeave); message CM_MOUSELEAVE;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    { Published declarations }
    property OnClick;
    property OnMouseDown;
    property OnMouseEnter: TMouseEnter read FMouseEnter write FMouseEnter;
    property OnMouseLeave: TMouseLeave read FMouseLeave write FMouseLeave;
    property OnMouseMove;
    property OnMouseUp;
    property ShowHint;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('AM Software', [TAMHotSpot]);
end;

{ TAMHotSpot }

procedure TAMHotSpot.CMMouseEnter(var Message: TCmMouseEnter);
begin
  if Assigned(FMouseEnter) then FMouseEnter(Self, Message);
end;

procedure TAMHotSpot.CMMouseLeave(var Message: TCmMouseLeave);
begin
  if Assigned(FMouseLeave) then FMouseLeave(Self, Message);
end;

constructor TAMHotSpot.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  ControlStyle := ControlStyle + [csOpaque];
  SetBounds(0, 0, 25, 25);
  Cursor := crHandPoint;
end;

destructor TAMHotSpot.Destroy;
begin
  inherited Destroy;
end;

procedure TAMHotSpot.Paint;
begin
  inherited Paint;
  with Canvas do
  begin
    Brush.Style := bsClear;
    if (csDesigning in ComponentState) then
    begin
      Pen.Style := psDash;
      Pen.Color := clBlack;
      Rectangle(0, 0, Width, Height);
    end
  end;
end;

end.
